global DMul :label;


extern DFrExp           :label;
extern DResult          :label;
extern FPIEEE_Signal    :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

<DMul>
    ar5 = sp;
    push ar6, gr6;
    ar6 = ar5;
    push ar1, gr1;
    ar1, gr1 = [ ar5 -= 4 ];
    push ar0, gr0;
    ar0, gr0 = [ --ar5 ];
    push ar2, gr2;
    push ar3, gr3;
    push ar4, gr4;
    push ar5, gr5;
    sp += 2;
    push ar0, gr0;
    call DFrExp;
    sp += 2;
    push ar1, gr1
        with gr6 = gr7;
    call DFrExp;
    ar5 = sp
        with gr6 or gr7;
    gr5 = [ --ar5 ]     //     
        with gr0 = gr0 xor gr1 noflags;     //  
    if <>0 delayed skip Abnormal;
    push ar0, gr0;      //  
    gr4 = [ --ar5 ];    //     
    // cond. skip Abnormal
    gr3 = [ ar5 -=  3 ]     //     
        with gr4 <<= 1;
    gr2 = [ --ar5 ]
        with gr5 C<<= 1;
    gr2 <<= 1;
    gr3 C<<= 1;
    gr4 >>= 1;
    gr7 = gr4
        with gr2 >>= 1;
    gr1 = gr2 *: gr7;
.repeat 15;
    gr1 = gr2 * gr7;
.endrepeat;
    gr0 = gr7
        with gr7 = gr3;
    gr6 = gr4 *: gr7;
.repeat 11;
    gr6 = gr4 * gr7;
.endrepeat;
    gr4 = gr0 << 9;
    gr0 >>= 23;
    gr0 += gr7;
    gr6 = gr6 + carry;
    gr7 = gr1 << 9;
    gr1 >>= 23;
    gr0 += gr7;
    gr7 = gr5
        with gr1 = gr1 + gr6 + carry;
    gr6 = gr2 *: gr7;
.repeat 11;
    gr6 = gr2 * gr7;
.endrepeat;
    gr0 += gr7;
    gr7 = gr5
        with gr1 = gr1 + gr6 + carry;
    gr2 = gr3 *: gr7;
.repeat 9;
    gr2 = gr3 * gr7;
.endrepeat;
    pop ar5, gr5    //  
        with gr2 = gr3 * gr7;
    ar5 = sp
        with gr2 = gr3 * gr7;
    gr3 = [ ar5 -= 3 ]  //   
        with gr2 >>= 1;
    gr6 = [ ar5 -= 4 ]  //   
        with gr7 C>>= 1;
    gr7 = 1023 - 3
        with gr1 += gr7;
    sp -= 8
        with gr2 = gr2 + carry;
    if <>0 delayed skip Res;
    gr3 += gr6;
    gr3 -= gr7;
    // cond. skip Res;

        // 0  gr2 -   
    gr7 = 32
        with gr2 = gr1;
    gr1 = gr0
        with gr3 -= gr7;
    gr0 = gr4
        with gr4 = false;

<Res>
    call DResult;
<Ret>
    [ ar6 -= 4 ] = ar0, gr0;
    pop ar5, gr5;
    pop ar4, gr4;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar0, gr0;
    pop ar1, gr1;
    pop ar6, gr6;
    return;

<Abnormal>
    nul;
    sp -= 10;
    if < skip NaN
        with gr7;
    if > skip Inf
        with gr4 or gr5;
    gr3 = [ ar5 -= 3 ];
    gr2 = [ --ar5 ];
    with gr2 or gr3;
<Inf>
    if =0 delayed skip Invalid;
    gr0 >>= 31;
    gr0 <<= 31;
    gr7 = 7ff00000h;
    with gr0 = gr0 or gr7;
    delayed skip Ret;
    gr7 = false;
    ar0 = gr7;
    // skip Ret;
<NaN>
    delayed skip Ret;
    gr0 = true;
    ar0 = gr0;
    // skip Ret
<Invalid>
    gr7 = _FPIEEE_Invalid;
    call FPIEEE_Signal;
    delayed skip Ret;
    gr0 = true;
    ar0 = gr0;
    // skip Ret

end text;
