//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          ftou64.asm                                      //
//                                                                          //
//        32          //
//       64 .                                //
// ConvFtoU64 -  float     .                  //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .    .

global ConvFtoU64 :label;


extern RShift32    :label;
extern LShift64     :label;
extern FFrExp       :label;
extern FPIEEE_Signal :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  ConvFtoU64 ==========================
//       32 
//       64 
//  : gr7 -  float 
//  :     -   .
//                -  .
// :       PC,PSW
// : ar5,gr7
<ConvFtoU64>
    push ar0,gr0 with gr0 = gr7;    // gr0 - 
    push ar6,gr6;

    if < skip Invalid;

    push ar0, gr0;
    call FFrExp;
    gr7 = 127 + 23;
    if <>0 delayed skip Invalid;
    pop ar0, gr0;
    with gr0 -= gr7;
    if < delayed skip Small;
    gr7 = 41;
    with gr0 - gr7;
    if u>= delayed skip Invalid;
    gr7 = gr0
        with gr0 = false;
    nul;
    // cond. skip Invalid
    push ar0, gr0;
    call LShift64;
    delayed skip Res;
    pop ar0, gr0;
    nul;
    // skip Res;
<Small>
    gr0 = -gr0;

    delayed call RShift32;
    push ar0, gr0;
    nul;
    // call RShift32

    ar0 = gr7 with gr0 = false;

<Res>
    ar5 = ar0 with gr7 = gr0;   // ar5 - ResLo, gr7 - ResHi
    pop ar6, gr6;
    pop ar0, gr0;

    delayed return;
    push ar5;
    push gr7;
    nul;        // not executed
    // return;

<Invalid>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    pop ar6, gr6;
    pop ar0, gr0;
    return;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        ftou64.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
