//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// memchr.c,
//
//----------------------------------------------------------------

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif
const void * memchr (const void * ptr,int c, size_t length)
{
  register const unsigned char *src = (const unsigned char *)ptr;

  while (length > 0)
  {
    if (*src == c)
     return (void *)src;
    src++;
		length --;
  }
  return NULL;
}
